\chapter{The Finite Element Method}
\label{sec:fe_method}

\section{Elasticity Theory}
\label{sec:elasticity_theory}

In this section we provide a comprehensive introduction into linear
elasticity theory. It is done only as far and in the depth as we need
it for the implementation. See for a complete description
\citet{BonetWood2008} which is also basis of the lectures on {\it
  Elasticity Theory I} and on {\it Elasticity Theory II}. In this
chapter we will treat linear small deformation problems only. The main
parts of this linear theory where taught in the base lectures on {\it
  Strength of Materials} (\citet{CelFE1998}).

An appropriate description of the kinematics is always the basis for
doing continuum mechanics. In Figure~\ref{fig:cont_kinematics} the main terms
and definitions of the motion of a deformable body are given.

\begin{figure}[!ht]
  \centering
  \input{src_images/cont_kinematics.pdf_tex}
  \caption{A body (domain) $\Omega$ is given in the Lagrangian
    manifold (material, initial configuration) at time $t=0$ and in the
    Eulerian manifold (spatial, current configuration) at
    time $t$. In each configuration the point $\bfP$ is given as
    $^0\bfP$ and $^t\bfP$ respectively. The mapping of points $^0\bfx$
    in the material configuration onto $^t\bfx$ in spatial
    configuration is given by the function $\bfPhi(^o\bfx,t)$. The
    difference between a position vector in spatial $^t\bfx_P$ and
    material $^0\bfx_P$ configuration is called displacement
    $^t\bfu_P(^0\bfx_P,t)$. }
  \label{fig:cont_kinematics}
\end{figure}

\subsection{Stress}
\label{sec:stress}

At first we define a generally valid stress model based on the
Boltzmann model which uses forces $^t\bfF$ only (in comparison to a
Cosserat medium which is based on additional moments $^t\bfM$). You
can see the Boltzmann model visualized in
Figure~\ref{fig:cauchy_stress}. The stress vector $\bfsigma_n$ is
defined as

\begin{equation}
  \bfsigma_n = \lim_{\Delta a \rightarrow 0} \frac{\Delta ^t\bfF}{\Delta ^tA}
\end{equation}

\begin{figure}[!ht]
  \centering
  \input{src_images/stress.pdf_tex}
  \caption{The cross section through a body at spatial configuration
    time $t$ is shown. This cross section is characterized through the
    point vector $\bfx_P$ and a normal vector $\bfn$.}
  \label{fig:cauchy_stress}
\end{figure}

From a physical point of view it makes only sense to define stresses
on the spatial (current) configuration. Although we know from
elasticity theory that we are able to construct artificial stresses
which depend on properties of the material (initial) configuration. We
assume small deformations (the limits for linear analysis are given in
Eq.~\eqref{eq:linear_analysis_limits}) which then leads to the
assumption that

\begin{equation}
  \Delta ^tA \approx \Delta ^0A
\end{equation}

However, this is somehow artificial. We reference the distributed
forces of the material point on the spatial configuration to the area
of the undeformed body. In a non-linear analysis there are different
stress measures available which take this issue into account.

The cross section shown in Figure~\ref{fig:cauchy_stress} can be done
in three linear independent directions and therefor 3 stress vectors
$\bfsigma_x$, $\bfsigma_y$ and $\bfsigma_z$ are retrieved. Those are
assembled in stress tensor $\bfsigma$ of second order. 

\begin{equation}
  \bfsigma = \mat{ccc}{
    \sigma_{xx} & \sigma_{xy} & \sigma_{xz} \\
    \sigma_{yx} & \sigma_{yy} & \sigma_{yz} \\
    \sigma_{zx} & \sigma_{zy} & \sigma_{zz}
  }
\end{equation}

The first index of the stress component represents the direction of
the normal vector and the second index the coordinate direction of the
stress component itself. As already stated in
Figure~\ref{fig:cauchy_stress} there must be an equilibrium of the
internal forces. This leads to the differential equation of
equilibrium for statical problems

\begin{equation}
  \label{eq:bvp}
  \mbox{div} \bfsigma  + \bff^B = {\bf 0}
\end{equation}

where $\bff^B$ represents the distributed body forces. Only 6 of the 9
components of a stress tensor are independent, the stress tensor
$\bfsigma$ is symmetric which is a result of the rotational equilibrium
(see \citet{CelFE1998,CelFest2004}). We retrieve the well
known second order Cauchy stress tensor

\begin{equation}
  \bfsigma = \mat{ccc}{
    \sigma_{xx} & \sigma_{xy} & \sigma_{zx} \\
    \sigma_{xy} & \sigma_{yy} & \sigma_{yz} \\
    \sigma_{zx} & \sigma_{yz} & \sigma_{zz}
  }
\end{equation}

\begin{figure}[!ht]
  \centering
  \begin{tikzpicture} %%(0,0)(12,6)
    \path (3,4) node [name=s,shape=circle,draw] {\Large $\bfsigma$}
          (9,4) node [name=u,shape=circle,draw] {\Large $\bfu$}
          (6,2) node [name=e,shape=circle,draw] {\Large $\bfep$};
    \draw (u) -- (e);
    \draw (e) -- (s);
    \draw (9,4.8) node {\bf Displacements};
    \draw (3,4.8) node {\bf Stresses};
    \draw (6,0.8) node {\begin{minipage}{2.5cm}\begin{center}
          {\bf Strains} \\
          auxiliary \\
          quantities
        \end{center}\end{minipage}};
    \draw (3.9,2.3) node {\begin{minipage}{2.5cm}\begin{center}
        stress-\\
        strain-\\
        relations
      \end{center}\end{minipage}};
    \draw (8.1,2.3) node {\begin{minipage}{3cm}\begin{center}
        strain-\\
        displacement-\\
        relations
      \end{center}\end{minipage}};
  \end{tikzpicture}
  \caption{The main variables in continuum mechanics}
  \label{fig:main_variables}
\end{figure}

There is no direct relation between displacements and
stresses. Therefor auxiliary quantities, the strains, are introduced
and the kinematics delivers strain-displacement-relations. This allows
us to formulate a constitutive law (the stress-strain-relation). This
issue is illustrated in Figure~\ref{fig:main_variables}.

\subsection{Strain}
\label{sec:strain}

A very common start to define a strain measure is the right
Cauchy-Green deformation tensor {\bf C}. It describes the change of
the scalar product of two differential vectors, from the material
configuration to the spatial configuration. This means it describes
the deformation based on the initial configuration. With the help of
the deformation tensor $\bfF = \partial ^t\bfx / \partial ^0\bfx$ we
can write

\begin{equation}
  \de ^t\bfx_1^T \cdot \de ^t\bfx_2 = \de ^0\bfx_1^T \cdot \bfF^T \, \bfF \cdot \de ^0\bfx_2 = \de ^0\bfx_1^T \cdot \bfC \cdot \de ^0\bfx_2
\end{equation}

Now we can define the Lagrangian or Green strain tensor to

\begin{equation}
  \bfE = \frac{1}{2} \left( \bfC - \bfI \right)
\end{equation}

This Lagrangian strain tensor is not restricted to small movements or
small deformations. Let us consider one part of it, namely
$E_{xx}$

\begin{equation}
  E_{xx} = \partiel{^tu}{^0x} + \frac{1}{2} \left[ \left(\partiel{^tu}{^0x}\right)^2 + \left(\partiel{^tv}{^0x}\right)^2 + \left(\partiel{^tw}{^0x}\right)^2 \right]
\end{equation}

If we limit ourselves to small derivatives of the displacementes,
which means $\| \partiel{^tu_i}{^0x} \| \ll 1$, we can neglect the
non-linear term in the brackets. We end up with the well known
relations from linear theory for normal strains

\begin{equation}
  \varepsilon_{xx} = \partiel{^tu}{^0x} \; ; \quad \varepsilon_{yy} = \partiel{^tv}{^0y} \; ; \quad \varepsilon_{zz} = \partiel{^tw}{^0z}
\end{equation}

and for the shear strains

\begin{equation}
  \varepsilon_{xy} = \frac{1}{2} \left( \partiel{^tu}{^0y} + \partiel{^tv}{^0x} \right) \; ; \quad 
  \varepsilon_{yz} = \frac{1}{2} \left( \partiel{^tv}{^0z} + \partiel{^tw}{^0y} \right) \; ; \quad 
  \varepsilon_{zx} = \frac{1}{2} \left( \partiel{^tw}{^0x} + \partiel{^tu}{^0z} \right)
\end{equation}

For the linear case the mathematical strains $E_{ij}$ and the physical
strains $\varepsilon_{ij}$ are approximatively equal and therefore we
replace $E$ by $\varepsilon$. The limits for linear analysis are

\begin{equation}
  \label{eq:linear_analysis_limits}
  \varepsilon_{ii} \le 0.02 \; ; \quad \varepsilon_{ij} \le 0.1 \; (i \ne j)
\end{equation}

where a suitable derivation for this limits can be found in
\citet{CelFE1998}. It is also notable that for the linear case the
strains can be written in index notation in a very concise way

\begin{equation}
  \varepsilon_{ij} = \frac{1}{2} \left( \partiel{^tu_i}{^0x_j} + \partiel{^tu_j}{^0x_i} \right) \quad i,j = 1\dots3
\end{equation}

with $u_1 = u, u_2 = v, u_3 = w$ and $x_1 = x, x_2 = y, x_3 = z$. In
the following we will omit $^t$ for the displacements $\bfu$ and $^o$
for the coordinates in material configuration $\bfx$. It is a further
advantage of linear analysis in Lagrangian formulation that we do not
need other values from the kinematics.

\subsection{Strain-Stress Relation and Voigt's Notation}
\label{sec:strain_stress_voigt}

There are several possibilities to define a strain-stress
relation. The most general approach includes the definition of a so
called elastic potential $\psi$. Those potentials depend on the
state of deformation. That is not the case for linear analysis where
we assume that the constitutional behavior of the material is not
deformation dependent - for elastic materials this is the
St. Venant-Kirchhoff material. We would like to refer once again to
\citet{BonetWood2008} and the lecture {\it Elasticity Theory II} for
the treatment of non linear analysis.

\begin{align}
  \varepsilon_{xx} &= \frac{1}{E} \left( + \sigma_{xx} - \nu \sigma_{yy} - \nu \sigma_{zz}\right)\\
  \varepsilon_{yy} &= \frac{1}{E} \left(-\nu \sigma_{xx} + \sigma_{yy} - \nu \sigma_{zz}\right)\\
  \varepsilon_{zz} &= \frac{1}{E} \left(-\nu \sigma_{xx} - \nu \sigma_{yy} + \sigma_{zz}\right)\\
  \gamma_{xy} & = \frac{2 (1 + \nu)}{E} \: \sigma_{xy}  = \frac{1}{G} \: \sigma_{xy} \\
  \gamma_{yz} & = \frac{2 (1 + \nu)}{E} \: \sigma_{yz}  = \frac{1}{G} \: \sigma_{yz} \\
  \gamma_{zx} & = \frac{2 (1 + \nu)}{E} \: \sigma_{zx}  = \frac{1}{G} \: \sigma_{zx}
\end{align}

These relations can be transferred int a matrix notation if we
rearrange the strain and stress values from two dimensional matrix
objects into one dimensional arrays. This procedure was suggested by
Voigt (see \citet{Voigt2008}).

\begin{equation}
  \bfvarepsilon = \mat{c}{
    \varepsilon_{xx} \\
    \varepsilon_{yy} \\
    \varepsilon_{zz} \\
    2 \varepsilon_{xy} \\
    2 \varepsilon_{yz} \\
    2 \varepsilon_{zx}
  } = \mat{c}{
    \varepsilon_{xx} \\
    \varepsilon_{yy} \\
    \varepsilon_{zz} \\
    \gamma_{xy} \\
    \gamma_{yz} \\
    \gamma_{zx}
  } \quad ; \quad \bfsigma = \mat{c}{
    \sigma_{xx} \\
    \sigma_{yy} \\
    \sigma_{zz} \\
    \sigma_{xy} \\
    \sigma_{yz} \\
    \sigma_{zx}
  }
\end{equation}

With this notation we can write the constitutive law in matrix notation as

\begin{equation}
  \bfsigma = \mathbb{C} \cdot \bfvarepsilon
\end{equation}

with $\mathbb{C}$ being the elasticity matrix.

\begin{equation}
  \label{eq:C_3D}
  \mathbb{C} = 2 G \mat{cccccc}{
    \frac{1-\nu}{1-2\nu} & \frac{\nu}{1-2\nu} & \frac{\nu}{1-2\nu} & 0 & 0 & 0 \\
    \frac{\nu}{1-2\nu} & \frac{1-\nu}{1-2\nu} & \frac{\nu}{1-2\nu} & 0 & 0 & 0 \\
    \frac{\nu}{1-2\nu} & \frac{\nu}{1-2\nu} & \frac{1-\nu}{1-2\nu} & 0 & 0 & 0 \\
    0 & 0 & 0 & \frac{1}{2} & 0 & 0 \\
    0 & 0 & 0 & 0 & \frac{1}{2} & 0 \\
    0 & 0 & 0 & 0 & 0 & \frac{1}{2} \\
  }
\end{equation}

One might consider a special situation for two dimensional
analysis. Two assumptions for the third coordinate direction (normal
to the plate) are possible, either
%
\begin{enumerate}
\item the normal stress is zero (plane stress) or
\item the normal strain is zero (plane strain)
\end{enumerate}
%
For extensive treatment and derivation see \citet{CelFE1998}. We get
the two possible elasticity matrices as

\begin{equation}
  \label{eq:C_plane_stress}
  \mathbb{C}^{\mbox{plane stress}} = \frac{E}{1-\nu^2} \mat{ccc}{
    1 & \nu & 0\\
    \nu & 1 & 0\\
    0 & 0 & \frac{1-\nu }{2}
  }
\end{equation}

\begin{equation}
  \label{eq:C_plane_strain}
  \mathbb{C}^{\mbox{plane strain}} = \frac{E}{(1+\nu)(1-2\nu )}
  \mat{ccc}{
    1-\nu & \nu & 0\\
    \nu & 1-\nu & 0\\
    0 & 0 & \frac{1-2\nu }{2}
  }  
\end{equation}

We removed all values with ${}_{zz}$, ${}_{zx}$, ${}_{yz}$ indices
from the strain and stress tensor although not all of those have to be
zero. The normal strain $\varepsilon_{zz}$ for the plane stress and
the normal stress $\sigma_{zz}$ in the plane strain case are not zero!

There is a second advantage of Voigt's notation. It allows us to write
the strain array in a very compact form with the help of a
differential operator matrix $\bfD$.

\begin{equation}
  \bfvarepsilon = \bfD \cdot \bfu
\end{equation}

\begin{equation}
  \label{eq:differntial_operator_matrix_3D}
  \bfD = \mat{ccc}{
    \partiel{}{x} & 0 & 0 \\
    0 & \partiel{}{y} & 0 \\
    0 & 0 & \partiel{}{z} \\
    \partiel{}{y} & \partiel{}{x} & 0 \\
    0 & \partiel{}{z} & \partiel{}{y} \\
    \partiel{}{z} & 0 & \partiel{}{x} \\
  } \; ; \quad \bfu = \mat{c}{
    u \\ v \\ w
  }
\end{equation}

\subsection{Virtual Work Principle}
\label{sec:virtual_work}

There are different methods to derive the weak formulation of our
problem. For a full discussion of Ritz's method, Galerkin's method and
the derivation of the virtual work principle see
\citet{CelFE1998,CelFest2004}, \citet{ZienTayl2000} or
\citet{Bathe1996}.

Those principles end up in the following equation which represents the
equilibrium from Eq.~\eqref{eq:bvp} in an integral formulation (once
again for statics only)

\begin{alignat}{2}
  \delta W_{int} &+ \delta W_{ext} &= 0 \nonumber \\
  -\integral{V}{}{\delta \bfvarepsilon^T \cdot \bfsigma}{V} &+ \integral{V}{}{\delta \bfu^T \cdot \bff^B}{V} + \integral{S}{}{\delta \bfu^T \cdot \bff^S}{S} &= 0 \label{eq:virt_work_principle}
\end{alignat}

We can now insert the relations from the last two sections
($\bfvarepsilon = \bfD \cdot \bfu$, $\bfsigma = \mathbb{C} \cdot
\bfvarepsilon$) and yield the virtual work of the internal forces as

\begin{equation}
  \label{eq:d_W_int_cont}
  \delta W_{int} = -\integral{V}{}{\delta \bfu^T \cdot \bfD^T \cdot \mathbb{C} \cdot \bfD \cdot \bfu \;}{V}
\end{equation}

Eq.~\eqref{eq:virt_work_principle} is the starting point for the
finite element method.

\section{The Discretization}
\label{sec:discretization}

Until now we did all the formulations for a continuous displacement
field. We did not introduce any kind of discretization. During this
section we will apply the methods presented in
Chapter~\ref{chap:interpolation} and Chapter~\ref{chap:num_int} to
realize what we call the discretization. Here we introduce the
numerical character of the finite element method.

\begin{figure}[H]
  \centering
  \input{src_images/discretization.pdf_tex}  
  \caption{The discretization of the body $\Omega \rightarrow
    \Omega^{(m)}$ and the displacement field $\bfu(x,y) \rightarrow
    \bfu^{(m)}(r,s)$ is illustrated. On the left hand side we see the
    continuous domain $\Omega$ and on the right hand side the
    discretized domain $\Omega^{(m)}$. Element $(4)$ is also shown in
    natural coordinates on the bottom. The mapping from the natural
    coordinates to the global coordinates is given by the
    interpolation of the geometry. The displacement at a point $\bfP$
    inside an element also also given by the interpolation of the
    nodal displacements $\node{\bfu}^{(m)}$. We can use the same
    interpolation matrix for the geometry and the displacements.}
  \label{fig:discretization}
\end{figure}

Let us consider a two dimensional domain $\Omega$
(Figure~\ref{fig:discretization}). Inside this domain we select a
point $\bfP(x,y)$. At this point a displacement vector $\bfu_P(x,y)$
is given. Discretization means that we approximate the real continuous
displacement field with the help of the interpolation method (see
Chapter~\ref{chap:interpolation}). On the right hand side we know the
displacements in the nodes only. To get the displacement vector
$\bfu_P^{(m)}(r,s)$ for the discrete case we have to interpolate the
nodal displacements. In the end $\bfu_P^{(m)}(r,s)$ is only an
approximation of $\bfu_P(x,y)$ even if the nodal displacements
$\node{\bfu}^{(m)}$ are identical with the continuous displacements
at the nodal points.

That means we define {\bf nodes} inside (and on the boundary of) the
domain. Further we consider a patch of corresponding nodes - so called
{\bf elements}. The {\bf shape} of the elements is quadrilateral for
this example. It is of course possible to construct patches of
triangular shape or even patches with more then 4 (or 3 for triangular
shapes) nodes (see Section~\ref{sec:shape_functions} for higher order
shape functions and their construction). The boundaries of those
elements are called edges. The collection of elements, nodes and their
correspondence is called {\bf mesh}. This mesh defines the discretized
domain $\Omega^{(m)}$. It is obvious that the boundary is only
approximated by the discretized domain.

The nodal displacements of the corresponding nodes are collected in a
nodal displacement array (regarding to Voigt's notation) per element
$\node{\bfu}^{(m)}$.

\begin{equation}
  \label{eq:nodal_displacement_array}
  \node{\bfu}^{(m)} = \mat{cccccccc}{
    \node{u}_0 & \node{v}_0 & \node{u}_1 & \node{v}_1 & \node{u}_2 & \node{v}_2 & \node{u}_3 & \node{v}_3
  }^T
\end{equation}

%To simplify the distinction between nodal degrees of freedoms
%$\node{u}_i$, $\node{v}_i$, $\node{w}_i$ and the components of the
%displacement array $a_i$ we will rename $\node{\bfu}^{(m)} =
%\bfa^{(m)}$ which is fully equivalent.

The index is related to the {\bf local} node numbering and not to the
{\bf global} node numbers. For our two dimensional example two {\bf
  degrees of freedom} per node are defined $\node{u}_i$ and
$\node{v}_i$ (and $\node{w}_i$ in case of a three dimensional
problem).

For the interpolation we will use the shape matrix from
Section~\ref{sec:shape_functions} and
Eq.~\eqref{eq:quad_shape_matrix}. We have to expand the shape matrix
because we interpolate a vector field $\node{\bfu}^{(m)}$ and not a scalar
field $\node{\bfbeta}$ as in Eq.~\eqref{eq:scalar_interpolation}.

\begin{equation}
  \label{eq:fe_shape_matrix}
    \bfH(r,s) = \mat{ccccccccc}{
      h_0 & 0 & h_1 & 0 & h_2 & 0 & h_3 & 0 \\
      0 & h_0 & 0 & h_1 & 0 & h_2 & 0 & h_3
    }
\end{equation}

These interpolation matrices $\bfH(r,s)$ can be constructed in a
similar way for vector fields of arbitrary dimension. We can now
interpolate the vector field $\bfu^{(m)}(r,s)$. If we assume that the
``real'' continuous displacement and the nodal displacements are
approximately equal, we get an approximation of the displacement in
any point $\bfP(r,s)$ as

\begin{equation}
  \label{eq:disp_interpolation}
  \bfu(x,y) \approx \bfu^{(m)}[x(r),y(s)] = \bfH(r,s) \cdot \node{\bfu}^{(m)}
\end{equation}

Depending on the natural coordinates $r,s$ we are now able to
calculate the displacement at any point inside the domain
$\bfu^{(m)}(r,s)$ if the nodal displacements are given. That is
because the shape functions are defined in natural coordinates $r$ and
$s$ (and $t$ in the case of a three dimensional application). If one
wants to know the displacement at given coordinates $x,y$ on the
discretized domain one would need the inverse mapping $r(x),s(y)$
which is in general not known. It is part of the finite element method
that this kind of mapping is not needed.

As already discussed in Section~\ref{sec:shape_functions} the
definition of the shape (functions) matrix $\bfH(r,s)$ define the
shape of the element. We are using quadrilateral shape functions and
so the elements are quadrilaterals. It is straight forward to modify
the presented method to use triangular shape functions or extend it to
three dimensions and use hexahedral or tetrahedral shape
functions. One has to adjust the nodal displacement array
(Eq.~\eqref{eq:nodal_displacement_array}) of the element in an
appropriate way.

In a similar manner as we interpolate the displacement field we can
interpolate the geometry itself with

\begin{equation}
  \label{eq:isogeometric_interpolation}
  \bfx^{(m)}(r,s) = \bfH(r,s) \cdot \node{\bfx}^{(m)}
\end{equation}

and $\node{\bfx}^{(m)}$ being the nodal position matrix. This matrix
contains the coordinates of each corresponding node

\begin{equation}
  \label{eq:nodal_coordinate_matrix}
  \node{\bfx}^{(m)} = \mat{cccccccc}{
    \node{x}_0 & \node{y}_0 & \node{x}_1 & \node{y}_1 & \node{x}_2 & \node{y}_2 & \node{x}_3 & \node{y}_3
  }^T
\end{equation}

If we use the same shape functions for the displacements as for the
geometry we will call the procedure to be {\bf isogeometric}.

\subsection{Isoparametric Concept - The Jacobian Matrix}
\label{isoparametric}

The Jacobian Matrix, its inverse and its determinant are important
terms in a classical finite element formulation. We are going to use
the same interpolation scheme (shape function) for displacements and
geometry. We exploit this to define the Jacobian and we call this
concept isoparametric. The Jacobian matrix is defined as

\begin{equation}
  \label{eq:jacobian}
  \bfJ = \mat{cc}{
    \partiel{x}{r} & \partiel{x}{s} \\[2mm]
    \partiel{y}{r} & \partiel{y}{s}
  }
\end{equation}

for the two dimensional case. Of course this can be easily extended to
three dimensions and even to a one dimensional case. To calculate the
partial derivatives we use the isogeometric interpolation from
Eq.~\eqref{eq:isogeometric_interpolation} and yield

\begin{equation}
  \label{eq:jacobian_calculation}
  \mat{cccc}{\partiel{x}{r} & \partiel{x}{s} & \partiel{y}{r} & \partiel{y}{s} }^T = \bfH'(r,s) \cdot \node{\bfx}^{(m)} 
\end{equation}

with the derivative shape matrix (which can be extended to more
dimensions easily)

\begin{equation}
  \bfH'(r,s) = \mat{cccccccc}{
    \partiel{h_0}{r} & 0 & \partiel{h_1}{r} & 0 & \partiel{h_2}{r} & 0 & \partiel{h_3}{r} & 0 \\
    \partiel{h_0}{s} & 0 & \partiel{h_1}{s} & 0 & \partiel{h_2}{s} & 0 & \partiel{h_3}{s} & 0 \\
    0 & \partiel{h_0}{r} & 0 & \partiel{h_1}{r} & 0 & \partiel{h_2}{r} & 0 & \partiel{h_3}{r} \\
    0 & \partiel{h_0}{s} & 0 & \partiel{h_1}{s} & 0 & \partiel{h_2}{s} & 0 & \partiel{h_3}{s}
  }
\end{equation}

The derivatives have to be inserted into the Jacobian matrix according
to Eq.~\eqref{eq:jacobian}. The first derivative of the chosen shape
functions are known and coordinates of the nodes are part of the mesh
and therefore also known.

By inversion of $\bfJ$ (which has to be invertible, $\det(\bfJ) \ne \bf0$) one gets
$\bfJ^{-1}$.

\begin{equation}
  \label{eq:jacobian_inv}
  \bfJ^{-1}(r,s) = \mat{ccc}{
    \partiel{r}{x} & \partiel{r}{y} \\[2mm]
    \partiel{s}{x} & \partiel{s}{y} }
\end{equation}

\subsubsection{Jacobian Determinant for the Calculation of the Integral}
\label{sec:jacobian_determinant}

Especially for evaluating the Neumann boundary conditions
(Section~\ref{sec:neumann_bc}) we have to differ between different
cases to calculate the Jacobian determinant.

\begin{itemize}
\item We calculate the Jacobian matrix of an $n$-dimension element in
  an $n$-dimension coordinate System. E.g. we have a hexahedral shaped
  element in an three dimensional problem.
  % 
  $$\int \bfH^T(r,s,t) \; \bff^B(\bfx(r,s,t)) \det(\bfJ) \; \de r \, \de s \, \de t$$
  %
  Then the Jacobian matrix would be square.
  % 
  $$\bfJ = \mat{ccc}{
    \partiel{x}{r} & \partiel{x}{s} & \partiel{x}{t} \\[2mm]
    \partiel{y}{r} & \partiel{y}{s} & \partiel{y}{t} \\[2mm]
    \partiel{z}{r} & \partiel{z}{s} & \partiel{z}{t}
  }$$
  % 
  Here it is easy to calculate the determinant $\det(\bfJ)$
\item We need the Jacobian determinant for a surface integral embedded
  in a three dimensional problem.
  %
  $$\int {\bfH}^T(r,s) \; \bff^S(\bfx(r,s)) \det(\bfJ^S) \; \de r\, \de s$$
  % 
  Here we can calculate the determinant as
  % 
  $$\det(\bfJ^S) = \left\| \partiel{\bfx}{r} \times \partiel{\bfx}{s} \right\|$$
  % 
\item We need the Jacobian determinant for a line integral embedded
  in a three (or two) dimensional problem.
  % 
  $$\int {\bfH}^T(r) \; \bff^S(\bfx(r)) \det(\bfJ^S) \; \de r$$
  % 
  Here we can calculate the determinant with
  % 
  $$\det(\bfJ^S) = \left\| \partiel{\bfx}{r} \right\|$$
  % 
  which ends up in $\det(\bfJ^S) = \sqrt{\left(\partiel{x}{r}\right)^2
    + \left(\partiel{y}{r}\right)^2 + \left(\partiel{z}{r}\right)^2}$
  for the three dimensional case.
\end{itemize}

\subsection{Discrete Strains}
\label{sec:discrete_strains}

Now we are able to calculate the strain $\bfvarepsilon^{(m)}$ out of
the interpolated displacement field. We can describe the strain in
each point of domain by defining discrete displacement values in the
nodes. It is due to Voigt's notation and the reordering of a second
order strain tensor in a one dimensional array that we also want (and
have to) reorder the nodal displacement matrix.

\subsubsection{Two Dimensional Strain Matrix}

We define the nodal displacement array in local node numbers as (see
Eq.~\eqref{eq:nodal_displacement_array})

\begin{equation}
  \node{\bfu}^{(m)} = \mat{cccccccc}{\node{u}_0 & \node{v}_0 & \node{u}_1 & \node{v}_1 & \node{u}_2 & \node{v}_2 & \node{u}_3 & \node{v}_3}^T
\end{equation}

Here we assume a quadrilateral linear shape with $4$ nodes. It is easy
to extend this procedure to any polynomial order or shape type.

\begin{align}
  \bfvarepsilon^{(m)} &= \bfD \cdot \bfu^{(m)} \nonumber \\
  &= \underbrace{\bfD \cdot \bfH(r,s)}_{\dst \bfB(r,s)} \cdot \hat{\bfu}^{(m)}
\end{align}

The differential operator matrix $\bfD$ is not a classical matrix
containing numbers but differential operators. Therefore we can not
execute the matrix multiplication $\bfD \cdot \bfH(r,s)$ in a
numerical way. We do it here in a symbolic manner.

\begin{equation}
  \label{eq:B_matrix_2D}
  \bfB(r,s) = \mat{cccccccc}{
    \partiel{h_0}{x} & 0                & \partiel{h_1}{x} & 0                & \partiel{h_2}{x} & 0                & \partiel{h_3}{x} & 0                \\[2mm]
    0                & \partiel{h_0}{y} & 0                & \partiel{h_1}{y} & 0                & \partiel{h_2}{y} & 0                & \partiel{h_3}{y} \\[2mm]
    \partiel{h_0}{y} & \partiel{h_0}{x} & \partiel{h_1}{y} & \partiel{h_1}{x} & \partiel{h_2}{y} & \partiel{h_2}{x} & \partiel{h_3}{y} & \partiel{h_3}{x}
  }
\end{equation}

The interpolation functions $h_i(r,s)$ are functions of
$(r,s)$. Therefore we have to apply the chain rule.

\begin{equation}
  \partiel{h_i}{x_j} = \sum\limits_{k=0}^1 \partiel{h_i}{r_k} \cdot \partiel{r_k}{x_j} \qquad \mbox{with} \quad r_0 = r, r_1 = s
\end{equation}

The partial derivatives $\partiel{h_i}{r_k}$ can be written once again
in matrix notation which has been already done in
Section~\ref{sec:quad_shape_first_der} and
Eq.~\eqref{eq:quad_shape_matrix_first_der}.

\begin{equation}
  \partiel{h_i}{r_k} \simeq {\cal H}'(r,s) = \mat{c}{\partiel{{\cal H}(r,s)}{r} \\[2mm] \partiel{{\cal H}(r,s)}{s}} = 
  \mat{cccc}{\partiel{h_0}{r} & \partiel{h_1}{r} & \partiel{h_2}{r} & \partiel{h_3}{r} \\[2mm]
    \partiel{h_0}{s} & \partiel{h_1}{s} & \partiel{h_2}{s} & \partiel{h_3}{s} }
\end{equation}

What yet is missing is the term $\partiel{r_k}{x_j}$. This can be
interpreted as inverse Jacobian matrix defined in
Eq.~\eqref{eq:jacobian_inv}.

\begin{equation}
  \partiel{r_k}{x_j} \simeq \bfJ^{-1}(r,s)
\end{equation}

This means we can calculate an intermediate matrix ${\cal B}(r,s)$
containing the entries in the $\bfB(r,s)$ matrix with

\begin{equation}
  \label{eq:B_components}
  {\cal B}(r,s) = {\cal H}'(r,s)^T \cdot \bfJ^{-1}(r,s) = \mat{cc}{
    \partiel{h_0}{x} & \partiel{h_0}{y} \\[2mm]
    \partiel{h_1}{x} & \partiel{h_1}{y} \\[2mm]
    \partiel{h_2}{x} & \partiel{h_2}{y} \\[2mm]
    \partiel{h_3}{x} & \partiel{h_3}{y}
  }
\end{equation}

The sorting of ${\cal B}(r,s) \rightarrow \bfB(r,s)$ has to be done
manually. There is no classical matrix operation which can do
that.

\subsubsection{Three Dimensional Strain Matrix}

For the three dimensional case the displacement array can be written
as (for a linear hexahedral shape)

$$\node{\bfu}^{(m)} = \mat{cccccccccc}{\node{u}_0 & \node{v}_0 & \node{w}_0 & \node{u}_1 & \node{v}_1 & \node{w}_1 & \cdots & \node{u}_7 & \node{v}_7 & \node{w}_7}^T$$

and we end up with the $\bfB(r,s,t)$ matrix

\begin{equation}
  \label{eq:B_matrix_3D}
  \bfB(r,s,t) = \mat{cccccccc}{
    \partiel{h_0}{x} & 0                & 0                & \cdots & \partiel{h_7}{x} & 0                & 0                \\[2mm]
    0                & \partiel{h_0}{y} & 0                & \cdots & 0                & \partiel{h_7}{y} & 0                \\[2mm]
    0                & 0                & \partiel{h_0}{z} & \cdots & 0                & 0                & \partiel{h_7}{z} \\[2mm]
    \partiel{h_0}{y} & \partiel{h_0}{x} & 0                & \cdots & \partiel{h_7}{y} & \partiel{h_7}{x} & 0                \\[2mm]
    0                & \partiel{h_0}{z} & \partiel{h_o}{y} & \cdots & 0                & \partiel{h_7}{z} & \partiel{h_7}{y} \\[2mm]
    \partiel{h_0}{z} & 0                & \partiel{h_0}{x} & \cdots & \partiel{h_7}{z} & 0                & \partiel{h_7}{x}
  }  
\end{equation}

\subsection{The System of Equations}
\label{sec:system_of_equations}

For the finite element method we expect a set of linear equations to
be solved. Until now we have not seen the connection from our
equilibrium in integral (weak) form
(Eq.~\eqref{eq:virt_work_principle}) to the set of equations. This is
going to be developed in this section. The principles are the same for
the two dimensional and the three dimensional case. They are also
independent of the shape type. Therefore we will limit (more or less)
the explanations here to the two dimensional case for first order
(bilinear) quadrilateral shape functions.

Let us once again consider the virtual work principle and insert the
discretization we just developed (remember
Eq.~\eqref{eq:d_W_int_cont}). We will evaluate the integral over the
whole domain $\int_V$ through splitting the integral into a sum of
integrals over the elemental volumes $\sum_{(m)}\int_{V^{(m)}}$. The
shape functions only contribute to the integral of their own
elements. This local character of the shape functions is one major
advantage of the finite element method. We interpret the summation as
an assembling operatoration (see Section~\ref{sec:assembling}) so that
we can leave the nodal displacement vectors also locally. Further we
use the fact, that the nodal displacement values are constant with
respect to the integrand, and, therefore they can be pulled out of the
integral.

\begin{alignat}{3}
  - \integral{V}{}{\delta \bfvarepsilon^T \cdot \bfsigma}{V} &+ 
  \integral{V}{}{\delta \bfu^T \cdot \bff^B}{V} &&+ 
  \integral{S}{}{\delta \bfu^T \cdot \bff^S}{S} &= 0  \nonumber \\
  \sum_{(m)} \Big\{ \delta \hat{\bfu}^{{(m)}^T} \cdot \Big[ - \underbrace{ \integral{V^{(m)}}{}{\bfB^T \cdot \mathbb{C} \cdot \bfB}{V^{(m)}}}_{\bfK^{(m)}} \cdot \hat{\bfu}^{(m)} &+
    \underbrace{ \integral{V^{(m)}}{}{\bfH^T \cdot \bff^B}{V^{(m)}} }_{\bfF^{B(m)}_{ext}} &&+
    \underbrace{ \integral{S^{(m)}}{}{\bfH^T \cdot \bff^S}{S^{(m)}} }_{\bfF^{S(m)}_{ext}} \Big] \Big\} &= 0 
\end{alignat}

In this equation we can already see the element stiffness matrix
$\bfK^{(m)}$.

\begin{equation}
  \bfK^{(m)} = \integral{V^{(m)}}{}{\bfB^T \cdot \mathbb{C} \cdot \bfB}{V^{(m)}}
\end{equation}

We transfrom this integral over the element volume $\de V^{(m)}$ into
an integral over the natural domain $\de r \cdot \de s$.

\begin{equation}
  \bfK^{(m)} = \int\limits_{-1}^{+1} \int\limits_{-1}^{+1} \bfB^T(r,s) \cdot \mathbb{C} \cdot \bfB(r,s) \, h(r,s)  \det(\bfJ(r,s)) \; \de r \, \de s
\end{equation}

As shown in Section~\ref{sec:int_mapping} and applied in
Eq.~\eqref{eq:num_int_2D} we transform the exact integration into a
numerical quadrature. For the two dimensional case $i,j$ are the
indices of an integration point ($m$ integration points in $r$
direction and $n$ in $s$ direction, Figure~\ref{fig:int_2D}). As the
determinant of the Jacobian matrix maps the area of our element we
have additionally to multiply with the height $h$ of our element.

\begin{equation}
  \label{eq:element_stiffness}
  \bfK^{(m)} = \sum \limits_{i=1}^m \sum \limits_{j=1}^n \alpha_i \alpha_j \, 
  \bfB^T(r_i,s_j) \cdot \mathbb{C} \cdot \bfB(r_i,s_j)
  \, h \det(\bfJ)
\end{equation}

If we use Lagrangian polynomials as basis for our shape functions we
are able to integrate exactly. We only have to choose a sufficiently
large number of integration points. We get the following (still
scalar) equation

\begin{equation}
  \sum_{(m)} \Big\{ \delta \hat{\bfu}^{{(m)}^T} \cdot \Big[ - \bfK^{(m)} \cdot \hat{\bfu}^{(m)} + \bfF^{B(m)}_{ext} + \bfF^{S(m)}_{ext} \Big] \Big\} = 0
\end{equation}

It is part of the virtual work principle that this equation has to
fulfilled for arbitrary values of $\delta \hat{\bfu}^{(m)}$. But this
is only true if and only if the expression in $[\dots]$ is zero. And
now we retrieve the system of equations as

\begin{equation}
  \sum_{(m)} \Big\{ - \bfK^{(m)} \cdot \hat{\bfu}^{(m)} + \bfF^{B(m)}_{ext} + \bfF^{S(m)}_{ext} \Big\} = {\bf 0}
\end{equation}

By execution of the assembling algorithm (see
Section~\ref{sec:assembling}) we yield

\begin{equation}
  \bfK \cdot \bfa = \underbrace{ \bfF^B_{ext} + \bfF^S_{ext} }_{\bfF_{ext}}
\end{equation}

To distinguish the nodalThis is the finite element set of linear equations with $\hat{\bfu}$
being the global numbered unknown nodal displacements.

\subsection{Assembling Algorithm}
\label{sec:assembling}

The transition (summation) from $\bfK^{(m)} \rightarrow \bfK$ and
$\bfF_{\rm ext}^{(m)} \rightarrow \bfF_{\rm ext}$ is called {\bf
  assembling}.

It is the best to explain assembling with the help of an example which
can be found in Figure~\ref{fig:assembling}.

\begin{figure}[!ht]
  \centering
  \input{src_images/assembling.pdf_tex}
  \caption{We selected two arbitrary elements from an unstructured
    mesh. On the right hand side the same elements are shown in their
    natural coordinates. The global node numbers on the left side can
    be connected to local node numbers in the natural coordinates.}
  \label{fig:assembling}
\end{figure}

We have selected the elements $(1)$ and $(2)$ from an arbitrary
mesh. The section from this mesh containing both elements is shown in
Figure~\ref{fig:assembling}. The circled node numbers $\mcircled{1}$
to $\mcircled{6}$ are the global node numbers. It is obvious that the
two elements share the nodes $\mcircled{2}$ and $\mcircled{5}$. This
means that during the assemble procedure the concentrated stiffness
values of the element stiffness matrix sum up on these nodes.

The sketched connection between local node numbers and global node
numbers can be visualized in a table too.

\begin{equation*}
  \begin{array}{ccc}
    & \mbox{element (1)} & \mbox{element (2)}\\
    \begin{array}{l}
      \mbox{locally}\\
      \mbox{globally}
    \end{array} & 
    \begin{array}{cccc}
      0 & 1 & 2 & 3 \\
      \mcircled{1} & \mcircled{2} & \mcircled{5} & \mcircled{4}
    \end{array} &
    \begin{array}{cccc}
      0 & 1 & 2 & 3\\
      \mcircled{2} & \mcircled{3} & \mcircled{6} & \mcircled{5}
    \end{array}
  \end{array}
\end{equation*}

Now we have to connect the node number and coordinate direction with
our element and global stiffness matrix respectively. This index
mapping can be done with the expression

\begin{center}
  \label{index_calculation}
  \code{global\_index = (global\_node\_number - 1) * dimension + coord\_offset}
  \code{local\_index = local\_node\_number * dimension + coord\_offset}
\end{center}

\begin{itemize}
\item The \code{global\_node\_number} and \code{local\_node\_number} are
  equal to the node number of the actual node we are considering. As
  the global node numbering starts with 1 and the local node numbering
  with 0 we get the shown difference in the two mappings.
\item The \code{coord\_offset} is a variable containing 0 for the $u$
  ($x$) direction, 1 for $v$ ($y$) and 2 for $w$ ($z$). This is due to
  the fact that one node has more than degree of freedom with respect
  to the displacement. For a 2D problem \code{coord\_offset} $\in
  [0,1]$.
\item \code{dimension} is the number of independent coordinate
  directions for a node. For a two dimensional analysis \code{dimension}
  would be 2.
\end{itemize}

The mapping is more or less arbitrary. We selected a very simple
relation but also very common one. The downside of this relation
between degree of freedom and position in the stiffness matrix (at
least for the global stiffness matrix) is the strong relation between
the nodal numbering and the bandwidth of the system. We also have to
assume that the global node numbering is strictly increasing without
any numbering blanks. But that is not a big issue as all meshers
provide meshes with strictly increasing numbers, else it would be easy
to do some renumbering. The mapping for the element stiffness matrix
is illustrated in Figure~\ref{fig:element_stiffness_index}.

\begin{figure}[H]
  \begin{tikzpicture}
    \def\firstoffset{3.1}
    \def\colwidth{1.25}
    
    \foreach \x in {0,2,4,6} {
      \pgfmathparse{\firstoffset + \colwidth*\x}
      \global\let\pos\pgfmathresult
      \draw (\pos,3.6) -- +(0,-6.); }
    
    \foreach \x in {1,3,5} {
      \pgfmathparse{\firstoffset + \colwidth*\x}
      \global\let\pos\pgfmathresult
      \draw (\pos,4.4) -- +(0,-6.8); }
    
    \foreach \x in {0,1,2,3} {
      \pgfmathparse{\firstoffset - .5 * \colwidth + 2 * \x * \colwidth}
      \global\let\pos\pgfmathresult
      \node[anchor=south, align=center] () at (\pos,3.) {$0$};
      \node[anchor=south, align=center] () at (\pos,2.4) {$\delta u_{\x}$}; }
    
    \foreach \x in {0,1,2,3} {
      \pgfmathparse{\firstoffset + .5 * \colwidth + 2 * \x * \colwidth}
      \global\let\pos\pgfmathresult
      \node[anchor=south, align=center] () at (\pos,3.) {$1$};
      \node[anchor=south, align=center] () at (\pos,2.4) {$\delta v_{\x}$}; }
    
    \pgfmathparse{\firstoffset - \colwidth}
    \global\let\pos\pgfmathresult
    \node[anchor=south east] () at (\pos,3.) {\code{coord\_offset}};
    \node[anchor=south east] () at (\pos,3.7) {\code{local\_node\_number}};

    \foreach \x in {0,1,2,3} {
      \pgfmathparse{\firstoffset + 2 * \x * \colwidth}
      \global\let\pos\pgfmathresult
      \node[anchor=south, align=center] () at (\pos,3.7) {$\x$}; }
    
    \node[anchor=west] (matrix) at (0,0) 
    {$ \bfK^{(m)} = \left[ \begin{array}{cccccccc}
          K_{00}^{(m)} & K_{01}^{(m)} & K_{02}^{(m)} & K_{03}^{(m)} & K_{04}^{(m)} & K_{05}^{(m)} & K_{06}^{(m)} & K_{07}^{(m)} \\
          K_{10}^{(m)} & K_{11}^{(m)} & K_{12}^{(m)} & K_{13}^{(m)} & K_{14}^{(m)} & K_{15}^{(m)} & K_{16}^{(m)} & K_{17}^{(m)} \\    
          K_{20}^{(m)} & K_{21}^{(m)} & K_{22}^{(m)} & K_{23}^{(m)} & K_{24}^{(m)} & K_{25}^{(m)} & K_{26}^{(m)} & K_{27}^{(m)} \\    
          K_{30}^{(m)} & K_{31}^{(m)} & K_{32}^{(m)} & K_{33}^{(m)} & K_{34}^{(m)} & K_{35}^{(m)} & K_{36}^{(m)} & K_{37}^{(m)} \\    
          K_{40}^{(m)} & K_{41}^{(m)} & K_{42}^{(m)} & K_{43}^{(m)} & K_{44}^{(m)} & K_{45}^{(m)} & K_{46}^{(m)} & K_{47}^{(m)} \\    
          K_{50}^{(m)} & K_{51}^{(m)} & K_{52}^{(m)} & K_{53}^{(m)} & K_{54}^{(m)} & K_{55}^{(m)} & K_{56}^{(m)} & K_{57}^{(m)} \\    
          K_{60}^{(m)} & K_{61}^{(m)} & K_{62}^{(m)} & K_{63}^{(m)} & K_{64}^{(m)} & K_{65}^{(m)} & K_{66}^{(m)} & K_{67}^{(m)} \\    
          K_{70}^{(m)} & K_{71}^{(m)} & K_{72}^{(m)} & K_{73}^{(m)} & K_{74}^{(m)} & K_{75}^{(m)} & K_{76}^{(m)} & K_{77}^{(m)} \\    
        \end{array} \right] $};
    
    \pgfmathparse{9 + \firstoffset}
    \global\let\pos\pgfmathresult
    \node[anchor=west] (disp) at (\pos,0)
    {$\begin{array}{l}  u_0^{(m)} \\ v_0^{(m)} \\ u_1^{(m)} \\ v_1^{(m)} \\ u_2^{(m)} \\ v_2^{(m)} \\ u_3^{(m)} \\ v_3^{(m)} \end{array}$};
  \end{tikzpicture}
  \caption{One can see the correlation between the indices in the
    element stiffness matrix and the \code{coord\_offset} and {\tt
      local\_node\_number} respectively. The situation is discussed by
    means of columns but is analogous valid for the rows.}
  \label{fig:element_stiffness_index}
\end{figure}

\begin{figure}[!ht]
  \begin{tikzpicture}
    \def\firstoffset{1.65}
    \def\yoffset{2.54}
    \def\colwidth{1.28}
    \def\rowheight{0.42}
        
    \foreach \x in {1,2,3,4,5,6} {
      \pgfmathparse{\firstoffset - .5 * \colwidth + 2 * (\x-1) * \colwidth}
      \global\let\pos\pgfmathresult
      \node[anchor=south, align=center] () at (\pos,3.2) {$0$};
      \node[anchor=south, align=center] () at (\pos,2.6) {\footnotesize $\delta u_{\x}$}; }
    
    \foreach \x in {1,2,3,4,5,6} {
      \pgfmathparse{\firstoffset + .5 * \colwidth + 2 * (\x-1) * \colwidth}
      \global\let\pos\pgfmathresult
      \node[anchor=south, align=center] () at (\pos,3.2) {$1$};
      \node[anchor=south, align=center] () at (\pos,2.6) {\footnotesize $\delta v_{\x}$}; }
    
    \foreach \x in {1,2,3,4,5,6} {
      \pgfmathparse{\firstoffset + 2 * (\x-1) * \colwidth}
      \global\let\pos\pgfmathresult
      \node[anchor=south, align=center] () at (\pos,3.8) {$\x$}; }

    \pgfmathparse{- 4 * \rowheight}
    \global\let\height\pgfmathresult
    \pgfmathparse{4 * \colwidth}
    \global\let\length\pgfmathresult

    \pgfmathparse{\firstoffset - \colwidth}
    \global\let\xpos\pgfmathresult
    \global\let\ypos\yoffset
    \draw[anchor=north west,fill=black,fill opacity=0.2, dashed] (\xpos,\yoffset) rectangle +(\length,\height);

    \pgfmathparse{\firstoffset + \colwidth}
    \global\let\xpos\pgfmathresult
    \pgfmathparse{\yoffset - 2 * \rowheight}
    \global\let\ypos\pgfmathresult
    \draw[anchor=north west,fill=black,fill opacity=0.2] (\xpos,\ypos) rectangle +(\length,\height);

    \pgfmathparse{\firstoffset + 5 * \colwidth}
    \global\let\xpos\pgfmathresult
    \pgfmathparse{\yoffset - 6 * \rowheight}
    \global\let\ypos\pgfmathresult
    \draw[anchor=north west,fill=black,fill opacity=0.2, dashed] (\xpos,\ypos) rectangle +(\length,\height);

    \pgfmathparse{\firstoffset + 7 * \colwidth}
    \global\let\xpos\pgfmathresult
    \pgfmathparse{\yoffset - 8 * \rowheight}
    \global\let\ypos\pgfmathresult
    \draw[anchor=north west,fill=black,fill opacity=0.2] (\xpos,\ypos) rectangle +(\length,\height);

    \foreach \x in {0,2,4,6,8,10} {
      \pgfmathparse{\firstoffset + \colwidth*\x}
      \global\let\pos\pgfmathresult
      \draw (\pos,3.7) -- +(0,-6.2); }
    
    \foreach \x in {1,3,5,7,9} {
      \pgfmathparse{\firstoffset + \colwidth*\x}
      \global\let\pos\pgfmathresult
      \draw (\pos,4.5) -- +(0,-7.); }
    
    \node[anchor=west] (matrix) at (0,0)
    {\footnotesize $\left[ \begin{array}{cccccccccccc}
          K_{00\,00} & K_{00\,01} & K_{00\,02} & K_{00\,03} & 0         & 0         & 0         & 0         & 0         & 0         & 0         & 0 \\ 
          K_{01\,00} & K_{01\,01} & K_{01\,02} & K_{01\,03} & 0         & 0         & 0         & 0         & 0         & 0         & 0         & 0 \\ 
          K_{02\,00} & K_{02\,01} & K_{02\,02} & K_{02\,03} & K_{02\,04} & K_{02\,05} & 0         & 0         & 0         & 0         & 0         & 0 \\ 
          K_{03\,00} & K_{03\,01} & K_{03\,02} & K_{03\,03} & K_{03\,04} & K_{03\,05} & 0         & 0         & 0         & 0         & 0         & 0 \\ 
          0         & 0         & K_{04\,02} & K_{04\,03} & K_{04\,04} & K_{04\,05} & 0         & 0         & 0         & 0         & 0         & 0 \\ 
          0         & 0         & K_{05\,02} & K_{05\,03} & K_{05\,04} & K_{05\,05} & 0         & 0         & 0         & 0         & 0         & 0 \\ 
          0         & 0         & 0         & 0         & 0         & 0         & K_{06\,06} & K_{06\,07} & K_{06\,08} & K_{06\,09} & 0         & 0 \\ 
          0         & 0         & 0         & 0         & 0         & 0         & K_{07\,06} & K_{07\,07} & K_{07\,08} & K_{07\,09} & 0         & 0 \\ 
          0         & 0         & 0         & 0         & 0         & 0         & K_{08\,06} & K_{08\,07} & K_{08\,08} & K_{08\,09} & K_{08\,10} & K_{08\,11} \\ 
          0         & 0         & 0         & 0         & 0         & 0         & K_{09\,06} & K_{09\,07} & K_{09\,08} & K_{09\,09} & K_{09\,10} & K_{09\,11} \\ 
          0         & 0         & 0         & 0         & 0         & 0         & 0         & 0         & K_{10\,08} & K_{10\,09} & K_{10\,10} & K_{10\,11} \\ 
          0         & 0         & 0         & 0         & 0         & 0         & 0         & 0         & K_{11\,08} & K_{11\,09} & K_{11\,10} & K_{11\,11} \\ 
        \end{array} \right]$};

    \pgfmathparse{14 + \firstoffset}
    \global\let\pos\pgfmathresult
    \node[anchor=west] (disp) at (\pos,0)
    {\footnotesize $\begin{array}{l} u_1 \\ v_1 \\ u_2 \\ v_2 \\ u_3 \\ v_3 \\ u_4 \\ v_4 \\ u_5 \\ v_5 \\ u_6 \\ v_6  \end{array}$};
  \end{tikzpicture}
  \caption{The global stiffness matrix is shown. One can see the
    correlation between the indices in the global stiffness matrix and
    the \code{coord\_offset} and \newline \code{global\_node\_number}
    respectively (once again only for columns but the numbering is
    analogous valid for the rows). Only non zero entries in the global
    stiffness matrix are labeled. The stiffness contributions of
    element $(1)$ are marked with a light gray filled dashed
    rectangle. The contributions of element $(2)$ with a solid line
    rectangle. One can also see the elements in the global stiffness
    where both elements contribute (darker shading).}
  \label{fig:global_stiffness_index}
\end{figure}

The same is true for a global stiffness matrix which is given in
Figure~\ref{fig:global_stiffness_index}. The blue boxes represent the
non zero values assembled from the element stiffnesses from element
$(1)$ and $(2)$. One can already see the bandwidth structure of the
global stiffness matrix. The shaded areas are those values where the
element stiffness values are summed up.

This means that we have to calculate the row and the column index of
one value in the element stiffness for the global stiffness. As an
example we show the assembling for the entry ${\bf K}_{02\,03}$ where
$02$ is the row and $03$ is the column index of the global stiffness
matrix (starting with 0).

\begin{equation*}
  \begin{array}{ll}
    {\bf K}_{02\,03}=
    {\bf K}_{23}^{(1)}+{\bf K}_{01}^{(2)}\\ 
  \end{array}
\end{equation*}

Further details on the implementation are given in the
Implementation~remark~\iref{impl:s.a.analysis.Analysis.assembleStiffness}.

\section{Dirichlet Boundary Conditions}
\label{sec:dirichlet_bc}

We follow an approach presented by \citet{WuXuLi2008}. This is a
rather simple but quite effective method of considering the Dirichlet
boundary conditions. We can integrate boundary conditions which can be
formulated in one single degree of freedom. Which means we can impose
a condition on the $u$ or $v$ direction of a node but cannot connect
the two degrees of freedom to realize an ``angular'' boundary
condition.

We assume the final assembled global stiffness matrix and load vector
with $n$ degrees of freedom and $m$ nodes. As we assume a two
dimensional problem $m = n / 2$. We will denote the global
displacement vector $\hat{\bfu}$ with $\bfa$ and therefore the $i$-th
component of the global nodal displacement vector as $a_i$ whereas the
horizontal displacement of node $j$ is denoted as $u_j$ and the
vertical as $v_j$.

\begin{equation}
  \underbrace{\mat{cccccc}{
      K_{00} & K_{01} & K_{02} & \cdots & K_{0(n-1)} \\
      K_{10} & K_{11} & K_{12} & \cdots & K_{1(n-1)} \\
      K_{20} & K_{21} & K_{22} & \cdots & K_{2(n-1} \\
      K_{30} & K_{31} & K_{32} & \cdots & K_{3(n-1} \\
      \vdots & \vdots & \vdots & \ddots & \vdots \\
      K_{(n-1)1} & K_{(n-1)2} & K_{(n-1)3} & \cdots & K_{(n-1)(n-1)} \\
    }}_{\dst \bf K} \cdot \underbrace{\mat{c}{\node{u}_1 \\ \node{v}_1 \\ \node{u}_2 \\ \node{v}_2 \\\vdots \\ \node{v}_m}}_{\dst \bf \node{u} = \bfa} = 
  \underbrace{\mat{c}{F_{x1} \\ F_{y2} \\ F_{x2} \\ F_{y2} \\ \vdots \\ F_{ym}}}_{\dst \bf F}
\end{equation}

We want to impose a boundary condition on $\node{v}_2$ (that is the
vertical displacement of the node with the global node number 2) with
$a_3 = \bar{v}_2$. We have to modify the system as follows

\begin{equation}
  \mat{cccccccc}{
    K_{00} & K_{01} & K_{02} & 0     & K_{04} & \cdots & K_{0n} \\
    K_{10} & K_{11} & K_{12} & 0     & K_{14} & \cdots & K_{1n} \\
    K_{20} & K_{21} & K_{22} & 0     & K_{14} & \cdots & K_{1n} \\
    0      & 0     &        & K_{33} &  0    & \cdots & 0 \\
    K_{40} & K_{41} & K_{42} &0      & K_{44} & \cdots & K_{4n} \\
    \vdots & \vdots & \vdots & \vdots & \vdots & \ddots & \vdots \\
    K_{(n-1)0} & K_{(n-1)1} & K_{(n-1)2} & 0 & K_{(n-1)4} & \cdots & K_{(n-1)(n-1)} \\
  } \cdot \mat{c}{\node{u}_1 \\ \node{v}_1 \\ \node{u}_2 \\ \bar{v}_2 \\ \node{u}_3 \\ \vdots \\ \node{u}_m} = 
  \mat{c}{\bar{F}_{x1} \\ \bar{F}_{y1} \\ \bar{F}_{x2} \\ K_{33} \, \bar{v}_2 \\ \bar{F}_{x3} \\ \vdots \\ \bar{F}_{ym}}
\end{equation}

The new entries in the load vector at the index $i$ must be calculated with

\begin{equation}
  \label{eq:load_vector_mod}
  \bar{F}_i = F_i - K_{i3} \, \bar{v}_{2}
\end{equation}

So we can summarize the algorithm for applying a boundary condition on
$a_\alpha$ (where $\alpha$ is the index of the degree of freedom in
the global displacement vector)

\begin{equation}
  \label{eq:dirichlet_bc}
  F_\alpha = K_{\alpha\alpha} \, a_\alpha \; ; \quad \bar{F}_i = F_i - K_{i\alpha} \, a_\alpha \; ; \quad K_{i\alpha} = K_{\alpha i} = 0 \quad \mbox{for} \;i = 0\dots(n-1), i \ne \alpha
\end{equation}

We and up with the modified equation system including the Dirichlet
boundary conditions

\begin{equation}
  \bar{\bf K} \cdot \hat{\bf u} = \bar{\bf F}
\end{equation}

Some further notes on the implementation of this algorithm are given
in the implementation remark
\ref{impl:s.a.analysis.Analysis.integrateDirichletBC}. For this
method the size of the equation system stays untouched. One can
consider a reduction of the system size as the imposed displacement
are already known and do not have to be solved again.

\section{Neumann Boundary Conditions}
\label{sec:neumann_bc}

For the external loads one has to consider the corresponding integral
in the virtual work principle.

\begin{align*}
  \delta W_{\rm ext} 
  &= \integralV{\delta \bfu^T \, \bff^B} + \integralS{\delta \bfu^T \, \bff^S} \\
  &= \delta \bfhu^T \, \underbrace{ \sum_{(m)} \Bigg[ \;\;
    \underbrace{ \integral{V^{(m)}}{}{\bfH^T (r,s,t) \, \bff^B(r,s,t)}{V^{(m)}}}_{\displaystyle\bfF_{\rm ext}^{B\;(m)}}+
    \underbrace{ \integral{S^{(m)}}{}{\bfH^T (r,s) \, \bff^S(r,s)}{S^{(m)}}}_{\displaystyle\bfF_{\rm ext}^{S\;(m)}} 
  \Bigg] }_{\displaystyle \bfF_{\rm ext}} \\
  &= \delta\bfhu^T \, \bfF_{\rm ext}
\end{align*}

Once again we can see the element wise character due to the local
shape functions. So we can define {\bf work conjugated} external
forces per element or per edge from distributed volume or surface
loads.

\subsection{Surface Loads}
\label{sec:surface_loads}

We split the boundary $S$ into discrete boundary segments $S^{(m)}$ -
we will call each of them an {\bf edge} (for the two dimensional case)
or {\bf face} (for the three dimensional case). To interpolate over
the edge (face) we use the same shape functions as for the
elements. As an edge is a one dimensional domain the shape function is
the Lagrange polynomial itself. For a face the shape function would be
a quadrilateral or triangle shaped one. This means also we can define
a reference configuration for each edge or face. 

\begin{figure}[!ht]
  \centering
  \input{src_images/work_conj_forces.pdf_tex}
  \caption{We start with the continuous problem at top of the
    figure. The body has an arbitrary shape surface on which we apply
    the constant pressure load p. Then we discretize the problem with
    a rather coarse mesh and end up with only two edges at the curved
    surface - edge $(13)$ and $(42)$. If we apply the load now we
    already see that the discrete load application is only an
    approximation of the real loading situation because the boundary
    is only approximated. To evaluate the integral for the work
    conjugated nodal forces we map the edges onto their natural
    coordinate system. In contrast to the element mapping we map only
    one natural coordinate $r$ in two global coordinates $x$ and
    $y$. This has been already discussed in
    Section~\ref{sec:jacobian_determinant}. It is important to note
    that on node $\mcircled{17}$ the edge contributions
    assemble. Therefore the nodal force at node $\mcircled{17}$ is
    much greater then the nodal forces in the nodes $\mcircled{33}$
    and $\mcircled{21}$ although the pressure is constant!}
  \label{fig:work_conj_forces}
\end{figure}

In Figure~\ref{fig:work_conj_forces} we analyze the situation for a
two dimensional example. We assume a {\bf constant} pressure as
surface load $\bff^S(r) = -p(r) \, \bfn$. Of course this just an
assumption, any external load can be applied in this way. Often we
have to interpolate the load itself if we describe the distribution by
discrete values in the nodes. To construct the normal vector we first
need the tangential vector which can be calculated with

\begin{equation}
  \bfa = \partiel{\bfx}{r} = \bfH'(r) \cdot \node{\bfx}^{(m)}
\end{equation}

The normal vector is given with

\begin{equation}
  \label{eq:normal_2D}
  \bfn = \frac{\bfa \times \bfe_3}{\left\| \bfa \times \bfe_3 \right\|}
\end{equation}

where $\bfe_3 = \mat{ccc}{0&0&1}^T$. It is really important that the
edge has to be numbered accordingly to achieve a normal vector which
points outwards. This is also true for surface loads on faces. Here we
can calculate two tangent vectors with give a matrix

\begin{equation}
  \bfA = \partiel{\bfx}{\bfr} = \bfH'(r,s) \cdot \node{\bfx}^{(m)}
\end{equation}

where $\bfa_r=\mat{ccc}{\bfA[0]&\bfA[2]&\bfA[4]}^T$ and 
$\bfa_s=\mat{ccc}{\bfA[1]&\bfA[3]&\bfA[5]}^T$. The normal vector is given as

\begin{equation}
  \label{eq:normal_3D}
  \bfn = \frac{\bfa_r \times \bfa_s}{\left\| \bfa_r \times \bfa_s \right\|}
\end{equation}

For the two dimensional example $\bfH(r)$ and $\bff^S(r)$ only depend
on $r$ and not on $s$ and we yield

\begin{equation}
  \label{eq:f_ext_S}
  \bfF_{\rm ext}^{S\;(m)} = \integral{S^{(m)}}{}{\bfH^T (r) \, \bff^S(r) }{S^{(m)}} = \integral{-1}{+1}{\bfH^T(r) \, \bff^S(r) \det(\bfJ^S) h}{r}  
\end{equation}

$\det(\bfJ^S)$ is of course nothing else then the length of edge so
that $\de S^{(m)} = \det(\bfJ^S) h \; \de r$. (see
Section~\ref{sec:jacobian_determinant})

\subsection{Body Forces}
\label{sec:body_force}

The situation is similar to Section~\ref{sec:surface_loads} and we yield

\begin{equation}
  \label{eq:f_ext_B}
  \bfF_{\rm ext}^{B\;(m)} = \integral{V^{(m)}}{} { \bfH^T(r,s,t) \, \bff^B(r,s,t) }{V^{(m)}} 
  = \int\limits_{-1}^{+1}\int\limits_{-1}^{+1}\int\limits_{-1}^{+1} \bfH^T (r,s,t) \, \bff^B(r,s,t) \det(\bfJ) \, \de r \de s \de t  
\end{equation}

If you provide the body force distribution by discrete values in the
nodes $\tilde{\bff}^B_i$ one has to collect them in a nodal body force
array $\node{\bff}^{B\;(m)}$ and interpolate the values into the
integration point at $r,s,t$ to get

\begin{equation}
  \bff^B(r,s,t) = \bfH(r,s,t) \cdot \node{\bff}^{B\;(m)}
\end{equation}

This means we end up for the external nodal body forces with

\begin{equation}
  \bfF_{\rm ext}^{B\;(m)} = \underbrace{ \int\limits_{-1}^{+1}\int\limits_{-1}^{+1}\int\limits_{-1}^{+1} \bfH^T(r,s,t) \cdot \bfH(r,s,t) \det(\bfJ) \, \de r \de s \de t}_{\mbox{"mass" matrix} \; \displaystyle \bfM} \; \cdot \; \tilde{\bff}^{B\;(m)}
\end{equation}

where the mass matrix $\bfM$ occurs. If one would integrate the mass
matrix with the density as weighting scalar $\int \bfH^T \rho \bfH \de
V$ we would obtain the mass distribution per node, that is the reason
why matrices of the character $\int \bfH^T \cdot \bfH \de V$ are
called ``mass'' matrices. A similar procedure can applied to surface
loads if they are given with discrete values at the nodes.

\section{Calculation of Strains and Stresses}
\label{sec:strain_stress}

The solution of the finite element equations delivers the displacement
vector $\node{\bfu}$. We know the displacement of every node in our
mesh. More often than being interested in the displacements engineers
want to know the stress distribution. Stress values can be used to do
the dimensioning. We will present here how the strain and stress
values can be calculated within the finite element method.

\subsection{Calculation of Strains}

To calculate the strains we use the $\bfB(r,s)$ matrix from
Eq.~\eqref{eq:B_matrix_2D} or $\bfB(r,s,t)$ from
Eq.~\eqref{eq:B_matrix_3D} for the three dimensional case. It is
therefore advantageous if one stores the $\bfB$ matrix during the
stiffness calculation per integration point. Then we can loop over all
integration points of all elements and calculate

\begin{equation}
  \bfepsilon^{(m)} = \bfB(r,s,t) \cdot \hat{\bfu}^{(m)}
\end{equation}

\subsection{Calculation of Stresses}
\label{eq:stress_calculation}

Once we have calculated the strains in each integration point it is
straight forward to calculate the stresses with

\begin{equation}
  \label{eq:fe_stress}
  \bfsigma^{(m)} = \mathbb{C} \cdot \bfepsilon^{(m)}
\end{equation}

on each integration point and once again store the result inside the
integration point.

\subsection{Nodal Strain and Stress Projection}
\label{sec:nodal_strain_stress_proj}

It is advantageous to know the stress values not only in the
integration points but also in the nodes. This is part of every
commercial finite element code. There exist different methods to
recover the stress values in the nodes. A rather famous one was
firstly presented by \citet{ZienZhu1987}. Despite the drawback of
having to solve a global system of equations it is still one of the
most precise methods. It is based on a very fundamental method of
numerics - the projective approximation (see \citet{Schwarz2006}).

The stress is proportional to the first derivative of the displacement
field. This is quite obvious if we consider a one dimensional truss.

\begin{equation}
  \sigma_{xx} = E \, \varepsilon_{xx} = E \, \partiel{u}{x}
\end{equation}

\begin{figure}[!ht]
  \centering
  \input{src_images/stress_proj.pdf_tex}
  \caption{The finite element approximation for truss elements. In the
    upper part of the picture the deviation between the interpolated
    and the real displacement field can be seen. This error exists
    even if the nodal displacement values coincide with the exact
    displacement field. Based on this linear interpolation of the
    displacement we end up with a piece-wise constant stress
    distribution $\sigma_{xx}^{(m)}$. The jumps at the element
    interfaces are a result of the $C^0$ only shape functions. With
    the projection algorithm we try to recover an enhanced stress
    distribution $\sigma_{xx}^*$ which represents the continuous
    stress distribution $\sigma_{xx}$ much better. After the nodal
    stress values $\hat{\sigma}_{xx}^*$ are calculated we can
    interpolate the recovered stress in the integration points
    $\sigma_{xx,IP}^*$. There is a notable difference between the
    finite element stress $\sigma_{xx,IP}^{(m)}$ and the enhanced
    stress $\sigma_{xx,IP}^*$.}
  \label{fig:stress_proj}
\end{figure}

In Figure~\ref{fig:stress_proj} we can see the approximative character
of the interpolated displacement field $\bfu^{(m)}$ in comparison to
the real displacement field $\bfu$ even if the nodal displacements
coincide. If we use these linear ansatz functions we end up with
piece-wise constant stress values inside an element. 

The projection algorithm we will use to recover enhanced nodal stress
values is given by
%
\begin{align}
  \sum_{(m)} \int\limits_{V^{(m)}} \bfH^{\sigma,T} \underbrace{ \left( \bfsigma^* - \bfsigma^{(m)} \right)}_{\mbox{stress deviation}} \de V^{(m)} &= {\bf 0}
\end{align}

We already calculated the discrete stress values $\bfsigma^{(m)}$
inside the integration points (see Section~\ref{eq:stress_calculation}
and Eq.~\eqref{eq:fe_stress}). We introduce an interpolation of the
enhanced stress distribution by defining nodal recovered stress values
$\hat{\bfsigma}^*$

\begin{equation}
  \label{eq:stress_projection}
  \bfsigma^* = \bfH^{\sigma} \cdot \hat{\bfsigma}^*
\end{equation}

with $\bfH^{\sigma}(r,s,t)$ being constructed to interpolate 6 values (see
Eq.~\eqref{eq:fe_shape_matrix} for the definition of $\bfH$) and yield

\begin{equation}
  \label{eq:stress_proj_mass_matrix}
  \underbrace{ \sum_{(m)} \int\limits_{V^{(m)}} \bfH^{\sigma,T} \cdot \bfH^{\sigma} \; \de V^{(m)} }_{\mbox{mass matrix} \dst \; \bfM^\sigma} \cdot \hat{\bfsigma}^* =  \underbrace{\sum_{(m)} \int\limits_{V^{(m)}} \bfsigma^{(m)} \de V^{(m)}}_{\dst \mbox{dist. array} \; \bfd}
\end{equation}

To retrieve the nodal stress values we have to calculate the mass
matrix $\bfM^\sigma$ and the disturbance vector on the right hand
side. Finally we have to solve the equation system

\begin{equation}
  \label{eq:stress_proj_eq_system}
  \bfM^\sigma \cdot \hat{\bfsigma}^* = \bfd
\end{equation}

which delivers the nodal stress values $\hat{\bfsigma}^*$. The whole
procedure described in this section can be applied on the strain
tensor too.

\section{Implementation}
\label{sec:impl_fe_method}

Everything related to the calculation is collected in the module {\tt
  soofea.analyzer} (abbr \code{s.a}). One can see it as counterpart to the {\tt
  soofea.model} (abbr \code{s.m}) module which mainly contains and manages data. Inside
this module, there is the main class {\tt
  s.a.analysis.Analysis} and its subclass {\tt
  s.a.analysis.LinearAnalysis}. The main job of these
classes is to provide the \code{run()} method, which realizes the
workflow of a finite element procedure (see
Figure~\ref{fig:analysis_run}).

\begin{figure}[!ht]
  \centering
  \begin{tikzpicture}
    [
    method/.style={rectangle,align=center,draw=black, thick},
    action/.style={circle,draw=black,thick}
    ]

    \node[method] (assembleStiffness) at (0,0) {\code{assembleStiffness(...)}};
    \node[method] (assembleLoad) at (0,-1.5) {\code{assembleLoad(...)}};
    \node[method] (integrateDirichlet) at (0,-3) {\code{integrateDirichletBC(...)}};
    \node[method] (integrateNeumann) at (0,-4.5) {\code{integrateNeumannBC(...)}};
    \node[action] (solve) at (0,-6) {solve};
    \node[method] (updateDOF) at (0,-7.5) {\code{updateDOF(...)}};
    \node[method] (strainStress) at (0,-9) {\code{calcStrainStress(...)}};

    \draw [->] (assembleStiffness) to (assembleLoad);
    \draw [->] (assembleLoad) to (integrateDirichlet);
    \draw [->] (integrateDirichlet) to (integrateNeumann);
    \draw [->] (integrateNeumann) to (solve);
    \draw [->] (solve) to (updateDOF);
    \draw [->] (updateDOF) to (strainStress);

    \node[align=left,anchor=west] at (4,0) {$\bfK^{(m)} \rightarrow \bfK$};
    \node[align=left,anchor=west] at (4,-1.5) {$\bfF^{S\,(m)}_{ext}$, $\bfF^{B\,(m)}_{ext} \rightarrow \bfF_{ext}$};
    \node[align=left,anchor=west] at (4,-3) {$\bar{u}_i \rightarrow u_i$};
    \node[align=left,anchor=west] at (4,-4.5) {$\bfF_{ext,i} \rightarrow \bfF_{ext}$};
    \node[align=left,anchor=west] at (4,-6) {$\bfK \cdot \hat{\bfu} = \bfF_{ext}$};
    \node[align=left,anchor=west] at (4,-9) {\begin{minipage}{0.3\linewidth}$$
        \begin{array}{rcl}
          \bfepsilon^{(m)}(r,s,t) &=& \bfB(r,s,t) \cdot \hat{\bfu}^{(m)} \\
          \bfsigma^{(m)}(r,s,t) &=& \mathbb{C} \cdot \bfepsilon^{(m)}(r,s,t)
        \end{array}$$\end{minipage}};
  \end{tikzpicture}
  \caption{The workflow of a linear finite element analysis is
    illustrated. At first we have to fetch the element stiffness of
    each element and assemble it into the global stiffness
    matrix. This is done inside the method {\tt
      assembleStiffness()}. Then we iterate over all elements, faces
    and edges (if they exist) and calculate the load
    contributions. Those are then assembled into the global load
    vector which is implemented in the method {\tt
      assembleLoad()}. After this procedure, the set of linear
    equations is still singular. We have to incorporate the boundary
    conditions. In \code{integrateDirichletBC()} we do so for the
    Dirichlet and in \code{integrateNeumannBC()} we do so for the
    Neumann boundary conditions. Then we can solve the system of
    finite element equations. As a result we get the global
    displacement vector which is then written back in the {\tt
      s.m.dof.DisplacementDOF()} to be stored in the
    model. Now we can calculate the strain and stress values at each
    integration point. We further execute the stress projection from
    Section~\ref{sec:nodal_strain_stress_proj}.}
  \label{fig:analysis_run}
\end{figure}

\subsection{\code{soofea.analyzer.jacobian.Jacobian}}
\label{sec:s.a.jacobian}

\begin{figure}[!ht]
  \centering
  \begin{tikzpicture}
    \begin{class}[text width=9cm]{Jacobian}{0,0}
      \attribute{\_node\_container \iref{impl:s.a.jacobian.Jacobian}}
      \attribute{\_int\_point \iref{impl:s.a.jacobian.Jacobian}}
      \attribute{\_J \iref{impl:s.a.jacobian.Jacobian}}
      \operation{Jacobian( node\_container, int\_point )\iref{impl:s.a.jacobian.Jacobian}}
      \operation[1]{\_calc( self, int\_point )\iref{impl:s.a.jacobian.Jacobian}}
    \end{class}
    \begin{class}[text width=9cm]{ElementJacobian}{-3,-4.5}
      \inherit{Jacobian}
      \operation{ElementJacobian( element, int\_point )\iref{impl:s.a.jacobian.Jacobian}}
      \operation{get( self )}
      \operation{getDet( self )}
      \operation{getInv( self )}
    \end{class}
    \begin{class}[text width=11cm]{BoundaryJacobian}{1,-8.5}
      \inherit{Jacobian}
      \operation{BoundaryJacobian( boundary\_component, int\_point )\iref{impl:s.a.jacobian.Jacobian}}
      \operation{getDet( self )}
    \end{class}
  \end{tikzpicture}
  \caption{Signature of class \code{s.a.jacobian.Jacobian} and its
    subclasses.}
  \label{fig:sig:s.a.jacobian.Jacobian}
\end{figure}

\begin{impl}[\code{s.a.jacobian.Jacobian}]
  \label{impl:s.a.jacobian.Jacobian}
  In general, it is possible to calculate a Jacobian matrix for every
  \code{NodeContainer}. A \linebreak \code{NodeContainer} has a shape
  (and therefore a derivative shape) and a nodal coordinate
  matrix. This is what we need to evaluate
  Eq.~\eqref{eq:jacobian_calculation}. This evaluation is done inside
  the method \code{\_calc()} and will be executed only once during
  construction of the \code{Jacobian} object. In the case we need the
  Jacobian for an \code{Element}, we will use the class {\tt
    ElementJacobian} as interface. Here the matrix is quadratic and we
  can calculate the inverse. If we have a \code{BoundaryComponent}
  (like \code{Edge} or \code{Face}) the Jacobian is rectangular as we
  have more global coordinates than natural coordinates. Then we can
  only calculate the determinant according to the description in
  Section~\ref{sec:jacobian_determinant}.
\end{impl}

\subsection{\code{soofea.analyzer.analysis.Analysis}}
\label{sec:s.a.analysis.Analysis}

\begin{figure}[!ht]
  \centering
  \begin{tikzpicture}
    \begin{class}[text width=13.5cm]{Analysis}{0,0}
      \attribute{model}
      \operation{assembleStiffness( self, global\_stiffness ) \iref{impl:s.a.analysis.Analysis.assembleStiffness}}
      \operation{assembleLoad( self, global\_load ) \iref{impl:s.a.analysis.Analysis.assembleLoad}}
      \operation{integrateDirichletBC( self, global\_stiffness, global\_load ) \iref{impl:s.a.analysis.Analysis.integrateDirichletBC} }
      \operation{integrateNeumannBC(self, global\_load) \iref{impl:s.a.analysis.Analysis.integrateNeumannBC}}
      \operation{updateDOF(self, solution\_vector) \iref{impl:s.a.analysis.Analysis.updateDOF}}
      \operation{calcStrainStress(self) \iref{impl:s.a.analysis.Analysis.calcStrainStress}}
    \end{class}
    \begin{class}[text width=5cm]{LinearAnalysis}{0,-5.5}
      \inherit{Analysis}
      \operation{run(self) \iref{impl:s.a.analysis.Analysis.run}}
    \end{class}
  \end{tikzpicture}    
  \caption{Signature of class \code{s.a.analysis.Analysis} and its
    subclass \newline \code{s.a.analysis.LinearAnalysis}}
  \label{fig:sig:s.a.Analysis}
\end{figure}

\begin{impl}[\code{run()}]
  \label{impl:s.a.analysis.Analysis.run}
  This is the main method containing the application flow and it is
  called inside the main routine. The chronology of a linear analysis
  is described in Figure~\ref{fig:analysis_run}.
\end{impl}

\begin{impl}[\code{assembleStiffness()}]
  \label{impl:s.a.analysis.Analysis.assembleStiffness}
  This method performs the assembling described in
  Section~\ref{sec:assembling}. Therefore, it iterates over all
  elements and asks each element for its element stiffness. Then, do
  an iteration over all columns and rows of the element stiffness and
  insert (add) the stiffness values at the appropriate global indices
  in the global stiffness.
\end{impl}

\begin{impl}[\code{assembleLoad()}]
  \label{impl:s.a.analysis.Analysis.assembleLoad}
  This method assembles the load entries which may be necessary due to
  surface or body loads (see Section~\ref{sec:neumann_bc}). Therefore
  it iterates over all edges (or faces) and asks each of them for its
  load contribution. Then do a iteration over all entries of the local
  load vector and insert (add) the load values at the appropriate
  global index in the global load.
\end{impl}

\begin{impl}[\code{integrateDirichletBC()}]
  \label{impl:s.a.analysis.Analysis.integrateDirichletBC}
  This routine implements the algorithm presented in
  Eq.~\eqref{eq:dirichlet_bc}. It can be realized in three steps

  \begin{enumerate}
  \item Modify the load vector corresponding to Eq.~\eqref{eq:load_vector_mod}.
  \item Replace the columns and rows of the global stiffness matrix
    corresponding to constraint displacements with zeros. {\bf
      Attention:} Keep the main diagonal entries.
  \item Set the corresponding entry in the load vector $F_t = K_{tt}
    \, \bar{u}_t$.
  \end{enumerate}

  It is really important to do the modification of the load vector
  (Step 1.) before the other steps. If you have overwritten the
  stiffness values with zero they can not be used anymore to do the
  modification.
\end{impl}

\begin{impl}[\code{integrateNeumannBC()}]
  \label{impl:s.a.analysis.Analysis.integrateNeumannBC}
  It is quite easy to integrate concentrated nodal forces into the
  load vector if they are already given. Simply add the external load
  (corresponding to a node and a direction $u$, $v$ or $w$) into the
  load vector. We would like to remind once again that those work
  conjugated nodal forces have to be chosen in an appropriate way
  according to Eqs.~\eqref{eq:f_ext_S},\eqref{eq:f_ext_B}. The better
  but more sophisticated method to get the external contributions is
  implemented in the \code{assembleLoad()} procedure.
\end{impl}

\begin{impl}[\code{updateDOF()}]
  \label{impl:s.a.analysis.Analysis.updateDOF}
  This method is responsible for the transport of the results from the
  \code{solution\_vector} into the model. Therefore, it updates
  corresponding displacement degrees of freedom in \code{s.m.Node.dofs}.
\end{impl}

\begin{impl}[\code{calcStrainStress()}]
  \label{impl:s.a.analysis.Analysis.calcStrainStress}
  First we calculate strain and stress values for every integration
  point. Then, we apply the stress projection procedure of
  Section~\ref{sec:nodal_strain_stress_proj}.
\end{impl}

\subsection{\code{soofea.analyzer.implementation.Impl}}
\label{sec:s.a.implementation.Impl}

The \code{s.a.implementation.Impl} is the base class for
all interfaces between the model and the analysis. Each {\tt
  ElementType}, \code{EdgeType}, \code{FaceType} holds
an appropriate object of either {\tt
  s.a.implementation.ElementImpl} or {\tt
  s.a.implementation.BoundaryImpl}. The first is
responsible for calculating stiffness and body force contributions. The
second is able to provide the contribution to the load vector from
surface loads.

\begin{figure}[!ht]
  \centering
  \begin{tikzpicture}
    \begin{class}[text width=5cm]{Impl}{0,0}
    \end{class}
    \begin{class}[text width=11cm]{BoundaryImpl}{-2,-2.5}
      \inherit{Impl}
      \operation[0]{calcLoad( self, boundary\_component ) \iref{impl:s.a.implementation.BoundaryImpl.load}}
      \operation[1]{\_loadIntegrator( self, int\_point, parameters ) \iref{impl:s.a.implementation.BoundaryImpl.load}}
    \end{class}
    \begin{class}[text width=13.5cm]{ElementImpl}{1.5,-5.5}
      \inherit{Impl}
      \operation{calcStiffness( self , element ) \iref{impl:s.a.implementation.ElementImpl.stiffness}}
      \operation{calcLoad( self, element ) \iref{impl:s.a.implementation.ElementImpl.load}}
      \operation{calcMassMatrix( self, element, array\_length ) \iref{impl:s.a.implementation.ElementImpl.stress_proj}}
      \operation{calcProjectionVector( self, element ) \iref{impl:s.a.implementation.ElementImpl.stress_proj}}
      \operation[1]{\_stiffnessIntegrator( self, int\_point, parameters ) \iref{impl:s.a.implementation.ElementImpl.stiffness}}
      \operation[1]{\_loadIntegrator( self, int\_point, parameters ) \iref{impl:s.a.implementation.ElementImpl.load}}
      \operation[1]{\_massMatrixIntegrator( self, int\_point, parameters ) \iref{impl:s.a.implementation.ElementImpl.stress_proj}}
      \operation[1]{\_projectionVectorIntegrator( self, int\_point, parameters ) \iref{impl:s.a.implementation.ElementImpl.stress_proj}}
    \end{class}
  \end{tikzpicture}    
  \caption{Signature of class \code{s.a.implementation.ElementImpl}}
  \label{fig:sig:s.a.implementation.ElementImpl}
\end{figure}

\begin{impl}[\code{BoundaryImpl.calcLoad()}]
  \label{impl:s.a.implementation.BoundaryImpl.load}
  If a \code{pressure} or a surface load \code{f\_S} is defined inside a
  boundary component, like \code{Edge} or \code{Surface} as well as
  nodal surface load values, we integrate the method {\tt
    \_loadIntegrator}. Here we evaluate the expression given in
  Eq.~\eqref{eq:f_ext_S}. Therefore, we use the \code{getLoad()}
  interface of the \code{BoundaryComponent} - see
  Implementation~remark~\iref{impl:s.m.Edge.surface_load}.
\end{impl}

\begin{impl}[\code{ElementImpl.calcStiffness()}]
 \label{impl:s.a.implementation.ElementImpl.stiffness}
 Here we are using the numerical integrator implemented in the method
 \linebreak \code{soofea.math.num\_int.methodIntegrate(...)} according
 to Section~\ref{sec:soofea.math.num_int.methodIntegrate}. The
 integrator function $f(r,s,t)$ is realized in its own method {\tt
   \_stiffnessIntegrator()}. Inside this method, we calculate the
 contribution of each integration point to the element stiffness as
 stated in Eq.~\eqref{eq:element_stiffness}. The multiplication byh
 the integration point weights is done inside the {\tt
   methodIntegrate(...)} function.
\end{impl}

\begin{impl}[\code{ElementImpl.calcLoad()}]
  \label{impl:s.a.implementation.ElementImpl.load}
  If a body force \code{f\_B} is defined inside an \code{Element} or
  if nodal body force values are given, we integrate the method {\tt
    \_loadIntegrator}. Here we evaluate the expression given in
  Eq.~\eqref{eq:f_ext_S}. We use the \code{getLoad()} interface of the
  \code{Element} (see
  Implementation~remark~\iref{impl:s.m.Element.body_force}).
\end{impl}

\begin{impl}[Nodal stress projection of Section~\ref{sec:nodal_strain_stress_proj}]
  \label{impl:s.a.implementation.ElementImpl.stress_proj}
  For the nodal stress projection algorithm from
  Section~\ref{sec:nodal_strain_stress_proj}, we need the mass matrix
  $\bfM^\sigma$ and the volume integral of the stress values as
  disturbance vector (see Eq.~\eqref{eq:stress_projection}). The mass
  matrix is integrated in the \code{\_massMatrixIntegrator()} and the
  disturbance vector in \linebreak
  \code{\_projectionVectorIntegrator()}.
\end{impl}

\section{Examples}
\label{sec:fe_examples}

\begin{ex}
  As a simple test case for the quadrilateral shape functions and the
  Jacobian determinant calculate the volume ($\int_{V^{(m)}} \, 1 \,
  \de V^{(m)}$) of an element with the following nodal
  coordinates
  %
  \begin{equation}
    \node{\bfx}^{(m)} = \mat{cccccccc}{
      -1 & -2 & 3 & 1 & 2 & 4 & -3 & 5
    }^T \unit{mm} 
  \end{equation} 
  % 
  and height $h=2 \unit{mm}$. What happens if the coordinates of node
  3 and 4 would be interchanged?
\end{ex}

\begin{ex}[\ref{ex:software_normal_vectors}]
  \label{ex:boundary_get_load}
  Implement the method
  \code{BoundaryComponent.getLoad(self,int\_point)} which returns
  $\bff^S(r,s)$. Possible surface loads might be given via:
  \begin{itemize}
  \item The property \code{BoundaryComponent.pressure}. Then one has to
    create the load vector via $\bff^S(r,s) = p \, \bfn(r,s)$. The
    normal vector $\bfn(r,s)$ is returned by
    \code{Edge.getNormal(self,int\_point)} or
    \code{Face.getNormal(self,int\_point)}.
  \item The property \code{BoundaryComponent.f\_S}. This load vector
    can be directly added to the returned load vector as this load is
    constant over the \code{Edge} or \code{Surface}.
  \item The porperty \code{Node.f\_S} on each node of the
    \code{BoundaryComponent}. This also means that one has to
    interpolate the nodal values into the integration point
    \code{int\_point} first. It is only possible to add a load
    contribution if every \code{Node} in the \code{BoundaryComponent}
    has an surface load \code{Node.f\_S} assigned.
  \end{itemize}
\end{ex}

\begin{ex}
  \label{ex:element_get_load}
  Implement the method
  \code{Element.getLoad(self,int\_point)} which returns
  $\bff^B(r,s,t)$. Possible body loads might be given via:
  \begin{itemize}
  \item The property \code{Element.f\_B}. This load vector
    can be directly added to the returned load vector as this load is
    constant over the \code{Element}.
  \item The porperty \code{Node.f\_B} on each node of the
    \code{Element}. This also means that one has to interpolate the
    nodal values into the integration point \code{int\_point}
    first. It is only possible to add a load contribution if every
    \code{Node} in the \code{Element} has a body force
    \code{Node.f\_B} assigned.
  \end{itemize}
\end{ex}

\begin{ex}
  \label{ex:fe_boundary_jacobian}
  Implement the class \code{s.a.jacobian.BoundaryJacobian}
  and the method \code{getDet(self)} inside. One can find the
  corresponding mathematics in Section~\ref{sec:jacobian_determinant}.
\end{ex}

\begin{ex}[at least \ref{ex:interpol_linear_shape}]
  \label{ex:fe_edge_face_type}
  Implement the classes \code{s.m.type.EdgeType} and
  \code{s.m.type.FaceType}. Do not forget to add the correct
  mathematical integration points in the superclass constructor
  \code{s.m.type.Type.\_\_init\_\_()} to be able to integrate over one
  dimensional and two dimensional element shapes. (Hint: Eventually
  the shape type \code{'linear'} might be missing in the code part for
  the shape construction in the main constructor.)
\end{ex}

\begin{ex}
  \label{ex:fe_material_3D}
  Implement the elasticity matrix $\mathbb{C}$ from
  Eq.~\eqref{eq:C_3D} for the three dimensional case in the method
  \code{s.m.material.StVenantKirchhoffMaterial.getElasticityMatrix(self,dimension)}.
\end{ex}

\begin{ex}[\ref{ex:interpol_hex_shape}, \ref{ex:fe_material_3D}]
  \label{ex:fe_3D_element}
  Handle inside
  \code{s.a.implementation.ElementImpl.\_stiffnessIntegrator()} the
  three dimensional case. The $\bfB(r,s,t)$ matrix for this case is
  given in Eq.~\eqref{eq:B_matrix_3D}. Create a simple {\tt
    brick\_patch.py} example equivalent to the {\tt quad\_patch.py} to
  test the code.
\end{ex}

\begin{ex}[\ref{ex:software_displacement_array}]
  \label{ex:fe_int_point_stresses}
  In \code{s.a.analysis.Analysis.calcStrainStress()} implement a loop
  over all integration points of all elements and calculate the
  stresses (see Eq.~\eqref{eq:fe_stress}). \newline
  Use \code{s.m.NodeContainer.getDisplacementArray(self)} as interface to
  the $\bfu^{(m)}$ displacement array.
\end{ex}

\begin{ex}
  \label{ex:fe_load_assembler}
  Analogously to the \code{s.a.analysis.stiffnessAssembler()} method
  write a method \linebreak \code{s.a.analysis.loadAssembler()} which
  is able to assemble elementary loads (element, edge, face loads) to
  the global load vector. This method should be used inside the method
  \linebreak \code{s.a.analysis.assembleLoad()} for all
  \code{s.m.Element}s, \code{s.m.Face}s and \code{s.m.Edge}s of the
  model to deliver the load contributions.
\end{ex}

\begin{ex}[\ref{ex:fe_load_assembler}, \ref{ex:element_get_load}]
  \label{ex:fe_element_load}
  Inside the class \code{s.a.implementation.ElementImpl} write the
  method \code{calcLoad(self, element)}. This method is responsible to
  return the work conjugated forces to a body force $\bff^B$. See
  Example~\ref{ex:element_get_load} how to retrieve the load for a
  given integration point.  Use the \linebreak
  \code{soofea.math.num\_int.methodIntegrator()} function to realize
  the integration from Eq.~\eqref{eq:f_ext_B}.
\end{ex}

\begin{ex}[\ref{ex:fe_load_assembler}, \ref{ex:boundary_get_load}]
  \label{ex:fe_boundary_component_load}
  Inside the class \code{s.a.implementation.BoundaryImpl} write the
  method \code{calcLoad(self, element)}. This method is responsible to
  return the work conjugated forces for a surface load $\bff^S$. See
  Example~\ref{ex:boundary_get_load} how to retrieve the load for a
  given integration point.  Use the \linebreak
  \code{soofea.math.num\_int.methodIntegrator()} function to realize
  the integration from Eq.~\eqref{eq:f_ext_S}.
\end{ex}

\begin{ex}
  \label{ex:fe_stress_projection}
  Implement the method
  \code{s.a.analyzer.Analsis.calcStressStrain()}. First iterate over
  all integration points in all elements and calculate the stress
  array. Store the stress inside the integration point.
  
  Inside the class \code{s.a.implementation.ElementImpl} implement
  \code{calcMassMatrix()} and the corresponding integrator method. As
  a result the elemental mass matrix $\bfM^\sigma$ from
  Eq.~\eqref{eq:stress_proj_mass_matrix} should be returned.

  In the next step implement \code{calcProjectionVector()} inside
  \code{s.a.implementation.ElementImpl} and the corresponding
  integrator method. Here the array $\bfd$ from
  Eq.~\eqref{eq:stress_proj_mass_matrix} should be returned.

  Finally the linear set of equations given in
  Eq.~\eqref{eq:stress_proj_eq_system} has to be solved. The results
  $\node{\bfsigma}^*$ must be stored in the property \code{'stress'}
  inside each node.
\end{ex}

\begin{ex}[\ref{ex:fe_stress_projection}]
  \label{ex:fe_equivalent_stress}
  Calculate the principal normal and shear stresses for each
  \code{Node} and evaluate the equivalent stresses for the Tresca
  hypothesis (Schubspannungshypothese), Rankine hypothesis
  (Normalspannungshypothese) and von Mises hypothesis
  (Oktaederspannungshypothese).
\end{ex}

%%% Local Variables: 
%%% mode: latex
%%% TeX-master: "main"
%%% End: 
